$ verify = 'F$VERIFY(0)'
$!.. BUILDLIB.COM		Build FERMILIB.OLB anew
$ IF F$TRNLNM( "FERMI$LIB_LIBSRC") .EQS. "" THEN -
$	DEFINE	FERMI$LIB_LIBSRC	SOURCE_ROOT:[FERMILIB.ROUTINES]
$ rebuild = p1
$ INQNP := INQUIRE/NOPUNCTUATION
$ IF rebuild .EQS. "" THEN $ INQNP  rebuild  "Re-build FERMILIB.OLB [<Y>/N]? "
$ IF rebuild .EQS. "" THEN rebuild = "YES"
$ listings = p2
$ IF listings .EQS. "" THEN $ INQNP  listings  "Generate listings [Y/<N>]? "
$ IF listings .EQS. "" THEN listings = "NO"
$ IF (listings) THEN $ DIRECTORY/OUTPUT=FERMILIB/DATE/SIZE  FERMI$LIB_LIBSRC:
$ object := /OBJECT=OBJECT.TMP
$ IF (.NOT. rebuild) THEN object := /NOOBJECT
$ listing1 := /NOLIST
$ listing2 := /NOLIST
$ listing3 := /NOLIST
$ IF (.NOT. listings) THEN $ GOTO SKIP_LIST_SETUP
$ listing1 := /LIST=LISTING.TMP/CROSS_REFERENCE
$ listing2 := /LIST=LISTING.TMP
$ listing3 := /LIST=LISTING.TMP/SHOW=SYMBOLS
$SKIP_LIST_SETUP:
$ SET NOON
$ any_failed = 0
$READ_LOOP:
$ input = F$SEARCH("FERMI$LIB_LIBSRC:*.*")
$ IF input.EQS."" THEN $ GOTO END_LOOP
$ file_type = F$PARSE(input,,,"TYPE") - "."
$ file_name = F$PARSE(input,,,"NAME")
$ GOTO DO_'file_type'
$ WRITE SYS$OUTPUT "??Unknown source file type: ",file_name,".",file_type
$ GOTO READ_LOOP
$DO_C:
$ WRITE SYS$OUTPUT "$>>  CC       ",file_name
$ CC'object''listing3'  FERMI$LIB_LIBSRC:'file_name'
$ IF (.NOT. $status) THEN $ GOTO FAILURE_CONC
$ GOTO CONCATENATE
$DO_FOR:
$ WRITE SYS$OUTPUT "$>>  FORTRAN  ",file_name
$ FORTRAN'object''listing1'  FERMI$LIB_LIBSRC:'file_name'
$ IF (.NOT. $status) THEN $ GOTO FAILURE_CONC
$ GOTO CONCATENATE
$DO_MAR:
$ WRITE SYS$OUTPUT "$>>  MACRO    ",file_name
$ MACRO'object''listing1'/DISABLE=DEBUG  FERMI$LIB_LIBSRC:'file_name'
$ IF (.NOT. $status) THEN $ GOTO FAILURE_CONC
$ GOTO CONCATENATE
$DO_MSG:
$ WRITE SYS$OUTPUT "$>>  MESSAGE  ",file_name
$ MESSAGE'object''listing2'  FERMI$LIB_LIBSRC:'file_name'
$ IF (.NOT. $status) THEN $ GOTO FAILURE_CONC
$ GOTO CONCATENATE
$DO_PAS:
$ WRITE SYS$OUTPUT "$>>  PASCAL   ",file_name
$ PASCAL'object''listing1'/NOSTANDARD  FERMI$LIB_LIBSRC:'file_name'
$ IF (.NOT. $status) THEN $ GOTO FAILURE_CONC
$ GOTO CONCATENATE
$CONCATENATE:
$ IF (rebuild) THEN $ APPEND/NEW  OBJECT.TMP  MODULES.OBS
$ IF (listings) THEN $ APPEND/NEW  LISTING.TMP  FERMILIB.LIS
$ GOTO READ_LOOP
$FAILURE_CONC:
$ any_failed = 1
$ IF (listings) THEN $ APPEND/NEW  LISTING.TMP  FAILURES.LIS
$ GOTO READ_LOOP
$END_LOOP:
$ DEASSIGN  SOURCES
$ SET MESSAGE/NOFACILITY/NOSEVERITY/NOIDENTIFICATION/NOTEXT
$ DELETE OBJECT.TMP;*,LISTING.TMP;*
$ PURGE *.OBS,*.LIS
$ SET MESSAGE/FACILITY/SEVERITY/IDENTIFICATION/TEXT
$ IF (.NOT.any_failed) THEN $ GOTO SUCCEEDED
$ IF (rebuild) DELETE MODULES.OBS;*
$ rebuild = 0
$ IF (listings) THEN PRINT/DELETE FAILURES
$ WRITE SYS$OUTPUT "??One or more compilations/assemblies failed!"
$ EXIT	F$VERIFY(verify).OR.1
$SUCCEEDED:
$ IF (listings) THEN $ LCPRINT/DELETE FERMILIB
$ IF (.NOT.rebuild) THEN $ GOTO END_REBUILD
$ WRITE SYS$OUTPUT "  Creating new version of FERMILIB.OLB."
$ old_privs = F$SETPRV("SYSPRV")
$ SET MESSAGE/NOFACILITY/NOSEVERITY/NOIDENTIFICATION
$ LIBRARY/OBJECT/CREATE/LOG  FERMI$LIB:FERMILIB  MODULES.OBS
$!		Check for existance of FERMI$LIB:OLDFERMI.OBJ, if found insert
$!		those object modules into the library also.
$ oldobj = F$SEARCH("FERMI$LIB:OLDFERMI.OBJ")
$ IF oldobj.NES."" THEN  -
$	LIBRARY/OBJECT/INSERT/LOG  FERMI$LIB:FERMILIB  FERMI$LIB:OLDFERMI
$ PURGE  FERMI$LIB:FERMILIB.OLB
$ SET MESSAGE/FACILITY/SEVERITY/IDENTIFICATION/TEXT
$ SET FILE/TRUNCATE/OWNER_UIC=PARENT  FERMI$LIB:FERMILIB.OLB
$ old_privs = F$SETPRV(old_privs)
$ DELETE MODULES.OBS;*
$END_REBUILD:
$ EXIT	F$VERIFY(verify).OR.1
$!=============================================================================
$! BUILDLIB.COM
$!
$!+ BUILDLIB
$! Procedure to build FERMILIB.OLB by compiling/assembling the
$! source files of the library routines stored in the directory
$! FERMI$ROOT:[LIBRARY.SOURCES.ROUTINES].  This directory must
$! contain just the source files of routines for FERMILIB and
$! nothing else.  The file types of .C, .FOR, .MAR, .PAS, and .MSG
$! are used to select the compiler/assembler for the source file.
$! To use, execute as:
$!
$!      @FERMI$LIB_UTIL:BUILDLIB  [rebuild]  [listing]
$!
$! If the rebuild parameter is YES then a new version of the FERMILIB
$! library is made by re-assembling/compiling the sources.  The old
$! version is purged.  In order to create a new FERMILIB.OLB, you
$! must have SYSPRV or SETPRV privilege.
$!
$! If the listing parameter is YES, then a listing file will be
$! created and printed.
$!-
$!=============================================================================
$! Modifications:
$!  08-Jun-82	FJN	Created
$!  11-Jun-82	FJN	Add /DISABLE=DEBUG to MACRO
$!  08-Aug-82	FJN	Modified for VMS V3.0
$!  24-Aug-82	FJN	Moved routine sources into [FERMILIB.SOURCES.ROUTINES]
$!  21-Sep-82	FJN	Expanded HELP comments
$!  24-Sep-82	FJN	Added check for and insertion of OLDFERMI object
$!			modules when rebuilding FERMILIB also change to using
$!			F$SEARCH rather than DIRECTORY for file list.
$!  04-Oct-82	FJN	Shorten messages
$!  09-Oct-82	FJN	Add /CROSS_REF to FORTRAN and allow for C sources,
$!			add /NOSTANDARD to PASCAL commands
$!  10-Jan-83	FJN	Allow specification via parameters of rebuild and
$!			listing
$!  08-Jul-83	FJN	Replaced PRINT by LCPRINT
$!  30-Nov-83	FJN	Build library into FERMI$LIB and copy to SYS$LIBRARY
$!  07-Jan-84	FJN	Provide for question defaults and remove /CROSS_REF
$!			from CC commands, replacing with /SHOW=SYMBOLS
$!  08-Aug-84	FJN	Dropped FERMILIB from SYS$LIBRARY
$!  24-Jun-86	FJN	Moved/compressed comments, moved to SOURCE_ROOT tree
