#module  strcpy_upcase  "V1.0"

/*|++STRCPYUPC.C

 Facility: 
	Fermilab Accelerator Control System - VAX/VMS ACNET
	Fermilab VAX-11 C Extension Library.

 Abstract:
	VAX-11 C routine to copy a string, converting it to upcase at the
	same time.

 Environment:
	FERMICLIB routine.
|--*/

/*
 Modification History:
 Author: F. Nagy

 V1.0	07-Jan-84  FJN	Created out of ENDTAPE.C for FERMICLIB
*/

/******************
 * Include Files: *
 ******************/
#include  vaxtypes			/* VAX-11 C Type extensions */
#include  ctype				/* ASCII character typing */


/*+ STRCPY_UPCASE
  Copy from string to string and convert all characters to uppercase.

    int strcpy_upcase( instr, outstr )
    char *instr, *outstr;
 -or-
  nchr.wl.v = strcpy_upcase( instr.rt.ra, outstr.wt.ra )

 Returns the number of characters (not including the NUL) in the string.

 instr   pointer to input (NUL-terminated) string.
 out     pointer to output string buffer (can overlay input string).
-*/

int strcpy_upcase( in, out )
char *in;				/* Input string pointer */
char *out;				/* Output string pointer */
{
char tc;				/* Temporary character holder */
int nc = 0;				/* Character counter */

while ((tc = *in++) != '\0')
    {
    nc++;				/* Count string length */
    *out++ = _toupper( tc);		/* Uppercase the characters */
    }

*out = '\0';				/* Terminate output string */

return nc;
}
