	OPTIONS	/EXTEND_SOURCE
	INTEGER*4 FUNCTION LIB_CVT_STR_LT( string, clinks)
	IMPLICIT NONE
C
C+ LIB_CVT_STR_LT
C Converts and ASCII date and time into a longword count of seconds
C since January 1, 1972.  The input string must be in the DownTime
C format of "dd-mmm-yy hhmm".
C
C  status = LIB_CVT_STR_LT( string, clinks )
C
C status    completion status, returned by value.
C               SS$_NORMAL    successful return
C               SS$_IVTIME    invalid time value
C
C string    Input time as text string.  Passed by descriptor, read
C           only.
C
C clinks    Output time in seconds since January 1, 1972.  Longword
C           passed by reference, write only.
C-
	CHARACTER*14 string		!Input string
	INTEGER*4 clinks		!Output time in seconds
C
	CHARACTER*(*) FULLDATE_VMS	!Skeleton for VMS-style date
	PARAMETER (FULLDATE_VMS = 'DD-MMM-YYYY HH:MM:00.00')
	CHARACTER*24 tis		!Temporary input string
C
	INTEGER*4 status		!Completion status
	INTEGER*4 SYS$BINTIM		!ASCII to VMS binary time service
	REAL*8 clunks			!VMS time clunks
	INTEGER*4 LIB_CVT_VST_LT	!VMS time to clinks
C
	clinks = -1			!Returned on error
C
C Now using input string, stuff a temporary string in VMS ASCII time format.
C
	tis = FULLDATE_VMS		!Set skeleton
	CALL STR$UPCASE( tis(1:6), string(1:6))	!Day and month (UpperCased)
	tis(13:14) = string(11:12)	!Hour
	tis(16:17) = string(13:14)	!Minute
	tis(10:11) = string(8:9)	!Year
	IF (string(8:9) .LT. '72') THEN
	    tis(8:9) = '20'		!00..71 in input is really 2000..2071
	ELSE
	    tis(8:9) = '19'		!72..99 is 1972..1999
	ENDIF
C
C Convert to VMS binary time then into clinks.
C
	LIB_CVT_STR_LT = SYS$BINTIM( tis, clunks)
	IF (.NOT. LIB_CVT_STR_LT) RETURN
	LIB_CVT_STR_LT = LIB_CVT_VST_LT( clunks, clinks)
C
	RETURN
	END
C
C Author:	Al Thomas	Fermilab Accelerator/Operations
C Modification History:
C V1.0	22-Mar-86  FJN	Renamed as LIB_CVT_STR_LT, calling sequence modified,
C			and setup to be added to FERMILIB and installed as a
C			Datatrieve function.
C V1.1	23-May-86  FJN	Fixed to convert month to UpperCase always
