$ verify = 'F$VERIFY(0)'
$!.. DELEMPTY.COM		Delete empty directories from a tree
$!.. Description/history at end of file.
$!	Define symbol to facilitate recursive calling of this procedure
$ IF "''DELEMPTY'" .EQS. "" THEN DELEMPTY = "@" + F$ENVIRONMENT("PROCEDURE")
$ ON CONTROL_Y THEN $ GOTO DONE
$ ON WARNING THEN $ GOTO DONE
$ default = F$LOGICAL("SYS$DISK") + F$DIRECTORY()	!Save current defaults
$10$:
$ IF p1.NES."" THEN $ GOTO 20$
$ INQUIRE p1 "Root"
$ GOTO 10$
$20$:		!Check for /LOG qualifier on the root directory specification.
$ IF p2 .EQS. "*INNER" THEN $ GOTO SELECT_FINIS	!Already setup in outer call
$ select = 0					!Outer call, no select default
$ IF p2 .EQS. "" THEN $ GOTO SELECT_FINIS
$ select = 1					!Enable date selection
$ date_type = "RDT"				!Default is /MODIFIED
$ since = 0					!Default is /BEFORE
$ IF F$TYPE(p2) .EQS. "INTEGER" THEN $ GOTO SELECT_RELATIVE
$ quals = F$ELEMENT( 1, "/", p2)
$ IF quals .EQS. "/" THEN $ GOTO SELECT_QUAL_DONE
$ quals = p2
$ p2 = F$ELEMENT( 0, "/", p2)			!Remove qualifier from parameter
$ quals = quals - p2 - "/"				!Just leave qualifiers
$SELECT_QUAL_LOOP:
$ qual = F$ELEMENT( 0, "/", quals)
$ IF F$EXTRACT(0,3,qual) .EQS. "BAC" THEN date_type = "BDT"
$ IF F$EXTRACT(0,3,qual) .EQS. "CRE" THEN date_type = "CDT"
$ IF F$EXTRACT(0,3,qual) .EQS. "EXP" THEN date_type = "EDT"
$ IF F$EXTRACT(0,3,qual) .EQS. "MOD" THEN date_type = "RDT"
$ IF F$EXTRACT(0,3,qual) .EQS. "BEF" THEN since = 0
$ IF F$EXTRACT(0,3,qual) .EQS. "SIN" THEN since = 1
$ quals = quals - qual  - "/"
$ IF quals .NES. "" THEN $ GOTO SELECT_QUAL_LOOP
$SELECT_QUAL_DONE:
$ IF F$TYPE(p2) .EQS. "INTEGER" THEN $ GOTO SELECT_RELATIVE
$ match_date = F$CVTIME( p2, "COMPARISON", "DATE")
$ GOTO SELECT_FINIS
$SELECT_RELATIVE:				!Relative -> absolute date
$ IF p2 .LT. 0 THEN offset = F$STRING(p2)
$ IF p2 .GT. 0 THEN offset = "+" + F$STRING(p2)
$ match_date = F$CVTIME( "TODAY" + offset + "-00", "COMPARISON", "DATE")
$SELECT_FINIS:
$ ll = F$LENGTH(p1)
$ p1 := 'p1'
$ logging = F$LOCATE("/LOG",p1) .LT. ll
$ IF logging THEN p1 = p1 - "/LOG"
$!	Check for root directory in existence (if not create an error by
$!	attempting to OPEN the file).
$ rdev = F$PARSE( p1,"SYS$DISK:",, "DEVICE")
$ p1 = F$PARSE( p1,,, "DIRECTORY")
$ SET DEFAULT 'rdev'[0,0]
$ IF F$PARSE(p1).EQS."" THEN $ OPEN FILE 'p1'	!Report error and exit
$ SET DEFAULT 'p1'
$LOOP:				! Look for any subdirectories at this point.
$ filespec = F$SEARCH("*.DIR;1")
$ IF filespec.EQS."" THEN $ GOTO LOOPEND
$!	Got a subdirectory at current level, delete all files in the
$!	subdirectory and its lower levels (by recursion).
$ IF .NOT. logging THEN $ DELEMPTY	[.'F$PARSE(filespec,,,"NAME")']	*INNER
$ IF logging THEN $ DELEMPTY	[.'F$PARSE(filespec,,,"NAME")']/LOG	*INNER
$ GOTO LOOP
$LOOPEND:			! No subdirectories at this level, check files
$ IF F$SEARCH("*.*;*") .NES. "" THEN $ GOTO DONE
$!	Get current directory as file name of the .DIR file in the next higher
$!	level of the directory tree - deleting empty directory!
$ dir = (F$DIRECTORY()-"]"-">") 
$ above = F$PARSE("[-]",,,"DIRECTORY")
$ IF above.EQS."[000000]" THEN $ GOTO DONE	!Do not delete top-level dire
$ IF above.NES."[000000]" THEN dir = dir - (above-"]"-">") - "."
$ dfile = "[-]" + dir + ".DIR;1"
$ IF select THEN $ GOTO CHECK_SELECTION
$!	Change protection of the directory before deleting it.
$ SET PROTECTION=(OWNER:RWED,SYSTEM:RWED)	'dfile'
$ IF .NOT. logging THEN $ DELETE	'dfile'
$ IF logging THEN $ DELETE/LOG		'dfile'
$DONE:
$ SET DEFAULT 'default'
$ EXIT	F$VERIFY(verify).OR.1
$CHECK_SELECTION:
$ date = F$CVTIME( F$FILE_ATTRIBUTES( dfile, date_type), "COMPARISON", "DATE")
$ IF since .AND. (date .LTS. match_date) THEN $ GOTO DONE
$ IF (.NOT. since) .AND. (date .GES. match_date) THEN $ GOTO DONE
$!	Change protection of the directory before deleting it.
$ SET PROTECTION=(OWNER:RWED,SYSTEM:RWED)	'dfile'
$ IF .NOT. logging THEN $ DELETE	'dfile'
$ IF logging THEN $ DELETE/LOG		'dfile'
$ SET DEFAULT 'default'
$ EXIT	F$VERIFY(verify).OR.1
$!=============================================================================
$! DELEMPTY.COM
$!
$!+ DELEMPTY
$! Delete empty directories from a directory tree.
$!
$!	@FERMI$UTIL:DELEMPTY  root[/LOG]  [date_specifier]
$!
$! where root is the pathname of the root of the tree from which
$! dead branches (empty directories) are to be pruned.  Any directory
$! with files is left untouched (deletion proceeds from the base of the
$! tree upwards so entire "empty" trees can be deleted).  However, a
$! UFD-level directory will not be deleted from the Master File Directory
$! to preserve the base of the directory tree.
$!
$! The root specification may include a device name.  If the /LOG
$! qualifier is added to the root specification, then information
$! messages are output to the terminal.
$!
$!2 Date_Specifier
$! The date specification can be used to limit which empty directories
$! are deleted based on the date associated with the directory file and
$! the specified date.  The format of this parameter is:
$!
$!	date[/qualifier[/qualifier]]
$!
$! where date can be an absolute date (like "1-Jan-1986") or relative
$! to the current date given by the number of days offset from now (which
$! can be either positive or negative, like "-30").
$!
$! The defaults, if only a date is given, are /MODIFIED/BEFORE.
$!3 Qualifiers
$!/BACKUP
$! Selection is based upon testing the backup date of the directory file.
$!/BEFORE
$! The only directories deleted are those whose selected date is before
$! the specified date.  This is the default.
$!/CREATED
$! Selection is based upon testing the creation date of the directory file.
$!/EXPIRED
$! Selection is based upon testing the expiration date of the directory file.
$!/MODIFIED
$! Selection is based upon testing the revision date; date of the directory
$! was last modified (by creating a new file or deleting an old file).
$! This is the default.
$!/SINCE
$! The only directories deleted are those whose selected date is later
$! than the specified date.
$!-
$!=============================================================================
$! Modifications:
$!  24-Nov-85	FJN	Created from DELTREE for use in USCLEANER procedure
$!  21-Feb-86	FJN	Begin adding P2 parameter to control trimming based
$!			upon creation/modification date of directory
