$ verify = 'F$VERIFY(0)'
$!.. REMOTEPRINT.COM		Send print files to remote printers
$!.. Description/history at end of file.
$ ON CONTROL_Y THEN $ GOTO CLEAN_EXIT
$GET_LIST:
$ IF p2 .EQS. "" THEN $ INQUIRE  p2  "Files"
$ IF p2 .EQS. "" THEN $ GOTO GET_LIST
$ naq = F$ELEMENT( 0, "/", p1)		!Ignore any qualifiers
$ node = F$PARSE( naq,,, "NODE", "SYNTAX_ONLY")
$ qname = F$PARSE( naq,,, "NAME", "SYNTAX_ONLY")
$ qualifiers = ""
$ p1 = F$ELEMENT( 1, "/", p1)		!Get any "command" qualifiers
$ IF p1 .NES. "/" THEN qualifiers = "/" + p1
$ p1 = F$ELEMENT( 1, "/", p2)		!Get any qualifiers after the file list
$ IF p1 .NES. "/" THEN qualifiers = qualifiers + "/" + p1
$ p2 = F$ELEMENT( 0, "/", p2)		!Lose any qualifiers from file list
$ first = 1
$ files = ""
$ last = ""
$FILES_LOOP:				!Scan file list
$ file = F$ELEMENT( 0, ",", p2)		!Get first file specification
$ p2 = p2 - file			!Just remainder of file list
$ IF F$EXTRACT(0,1,p2) .EQS. "," THEN p2 = p2 - ","
$ IF first .AND. F$ELEMENT( 1, ".", file) .EQS. "." THEN -
$	file = file + ".LIS"		!Add default .LIS file type to 1st file
$ first = 0
$ last = F$PARSE( file, last)
$ IF F$SEARCH( last) .EQS. "" THEN $ GOTO MISSING_FILE
$ IF files .NES. "" THEN files = files + ","
$ files = files + file
$ IF p2 .NES. "" THEN $ GOTO FILES_LOOP
$ locale = F$ENVIRONMENT( "DEFAULT")	!Current default disk/directory
$ OPEN /WRITE	T2T	'node'"TASK=RMTPRINTER"
$ WRITE	T2T	locale
$ WRITE	T2T	files
$ WRITE	T2T	"/QUEUE=''qname' " + qualifiers
$ CLOSE	T2T
$CLEAN_EXIT:
$ EXIT	F$VERIFY(verify).OR.1
$MISSING_FILE:
$ WRITE SYS$OUTPUT "%REMOTEPRINT-F-NOSUCHFILE, no files found '",file,"'"
$ EXIT	F$VERIFY(verify).OR.1
$!=============================================================================
$!+ REMOTEPRINT
$! Print one or more files on remote printers.  Files (wildcards are acceptable)
$! must be in current default directory.
$!
$!	$ @REMOTEPRINT  node::queue [/qualifiers]  file[,...] [/qualifiers]
$!
$! The most useful qualifiers are /SETUP, /FEED, /HEADER and /FORM.  The file
$! selection qualifiers (such as /BEFORE, etc.) should not be used, but in
$! general any other PRINT command qualifier can be used.  If the file (or
$! the first file in a list) specification does not include a file type,
$! then a file type of ".LIS" will be appended to this file specification
$! (to simulate the PRINT command).
$!
$! For instance, a print command defined to use the 13th floor Talaris-800
$! for printing in "line printer" mode might look like:
$!
$!	$ FPR*INT :== @REMOTEPRINT  FNAL::WH13W_PRINT/SETUP=S814L
$!
$! The REMOTEPRINT procedure will attempt to verify that the files exist
$! before starting the network operations.  If at least one file is not
$! found for each specification in the list (i.e. wildcards are tested for
$! only a single match), then the error message "%REMOTEPRINT-F-NOSUCHFILE"
$! will be displayed.
$!-
$!=============================================================================
$! Modifications:
$!  22-Aug-86	FJN	Created to use 13th floor Talaris-800 in S814L mode
$!  27-Aug-86	FJN	Improved to check the list of files for "existance"
$!			using F$SEARCH and to add ".LIS" to first filename
$!			if no file type provided.
