/*+ $DIBDEF
  Module ($DIBDEF) of SYS$LIBRARY:LCLCDEF.TLB.

 Defines a structure (struct dib$buffer) for the device information
 buffer returned by the $GETDEV and $GETCHN system services.  The
 field names are the same as the offset names given in the documentation.
-*/
/* Extracted $DIBDEF from SYS$LIBRARY:STARLET on  8-SEP-1982 */

struct	dib$buffer  {
	long		dib$l_devchar;	/* Device characteristics bits */
	unsigned char	dib$b_devclass;	/* Device class */
	unsigned char	dib$b_devtype;	/* Device type */
	unsigned short	dib$w_devbufsiz; /* Device buffer size */
	long		dib$l_devdepend; /* Device dependent information */
	unsigned short	dib$w_unit;	/* Unit number */
	unsigned short	dib$w_devnamoff; /* Offset to device name string */
	long		dib$l_pid;	/* Process id of device owner */
	long		dib$l_ownuic;	/* Device owner UIC */
	short		dib$w_vprot;	/* Volume protection mask */
	unsigned short	dib$w_errcnt;	/* Error count */
	unsigned long	dib$l_opcnt;	/* Operation count */
	unsigned short	dib$w_volnamoff; /* Offset to volume label string */
	unsigned short	dib$w_recsiz;	/* Blocked record size (magtape) */
#define  DIB$S_DEVNAME	76		/* Length of device name buffer */
	char		dib$t_devname[DIB$S_DEVNAME]; /* Counted string! */
	unsigned long	dib$l_maxblock;	/* Disk: number of logical blocks */
	};
struct	{
	unsigned	: 32;
	unsigned	: 32;
					/* Disk devices */
	unsigned char	dib$b_sectors;	/* sectors/track */
	unsigned char	dib$b_tracks;	/* tracks/cylinder */
	unsigned short	dib$w_cylinders; /* cylinders/volume */
	};

#define  DIB$C_LENGTH    116	/* length of total buffer */
#define  DIB$K_LENGTH    116	/* length of total buffer */

/*
   End of $DIBDEF module.
*/
